aboutsummaryrefslogtreecommitdiff
path: root/net/GeoIP/files/geoipupdate.sh.in
diff options
context:
space:
mode:
Diffstat (limited to 'net/GeoIP/files/geoipupdate.sh.in')
-rw-r--r--net/GeoIP/files/geoipupdate.sh.in50
1 files changed, 25 insertions, 25 deletions
diff --git a/net/GeoIP/files/geoipupdate.sh.in b/net/GeoIP/files/geoipupdate.sh.in
index 73625467f8a2..b80f292527cc 100644
--- a/net/GeoIP/files/geoipupdate.sh.in
+++ b/net/GeoIP/files/geoipupdate.sh.in
@@ -1,31 +1,31 @@
#!/bin/sh
+set -eu
echo Fetching GeoIP.dat and GeoIPv6.dat...
-TEMPFILE=`mktemp %%DATADIR%%/GeoIP.dat-XXXXXX`
-if fetch -o - http://geolite.maxmind.com/download/geoip/database/GeoLiteCountry/GeoIP.dat.gz | gunzip >> $TEMPFILE ; then
- chmod 644 $TEMPFILE
- if ! mv $TEMPFILE %%DATADIR%%/GeoIP.dat ; then
- rm $TEMPFILE
- echo Unable to overwrite %%DATADIR%%/GeoIP.dat
- exit 2
+# arguments:
+# $1 URL
+# $2 output file name
+_fetch() {
+ url="$1"
+ out="$2"
+ TEMPFILE="$(mktemp "%%DATADIR%%"/GeoIP.dat-XXXXXX)"
+ trap 'rc=$? ; set +e ; rm -f "'"$TEMPFILE"'" ; exit $rc' 0
+ if fetch -o - "$url" | gunzip >> "$TEMPFILE" ; then
+ chmod 444 "$TEMPFILE"
+ if ! mv -f "$TEMPFILE" "%%DATADIR%%"/"$2" ; then
+ echo "Unable to replace %%DATADIR%%/$2"
+ return 2
+ fi
+ else
+ echo "$2 download failed"
+ return 1
fi
-else
- rm $TEMPFILE
- echo GeoIP.dat download failed
- exit 1
-fi
+ rm -f "$TEMPFILE"
+ trap - 0
+ return 0
+}
-TEMPFILE=`mktemp %%DATADIR%%/GeoIPv6.dat-XXXXXX`
-if fetch -o - http://geolite.maxmind.com/download/geoip/database/GeoIPv6.dat.gz | gunzip >> $TEMPFILE ; then
- chmod 644 $TEMPFILE
- if ! mv $TEMPFILE %%DATADIR%%/GeoIPv6.dat ; then
- rm $TEMPFILE
- echo Unable to overwrite %%DATADIR%%/GeoIPv6.dat
- exit 2
- fi
-else
- rm $TEMPFILE
- echo GeoIPv6.dat download failed
- exit 1
-fi
+_fetch "http://geolite.maxmind.com/download/geoip/database/GeoLiteCountry/GeoIP.dat.gz" GeoIP.dat
+
+_fetch "http://geolite.maxmind.com/download/geoip/database/GeoIPv6.dat.gz" GeoIPv6.dat